// $Id$

//=============================================================================
/**
 *  @file    util/pressure.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_BEE_UTIL_PRESSURE_H
#define JYUGEM_BEE_UTIL_PRESSURE_H
#ifdef _MSC_VER
#pragma warning( disable: 4355 )
#endif

#include "jyugem/bee/beelib.h"
#include "boost/tokenizer.hpp"
#include "physical-quantities/pqs.hpp"
#include <string>
#include <vector>
#include <cmath>

namespace jyugem { namespace bee { namespace util
{

using namespace std;
using namespace physical_quantities;

///////////////////////////////////////////////////////////////////////////////
template<typename ValueT>
ValueT torr2pa(ValueT v)
{
  q_pressure::torr    torr(v);
  ValueT pas_val = static_cast<ValueT>(floor(q_pressure::Pa(torr)() + 0.5));

  return  pas_val;
}

template<>
double torr2pa(double v)
{
  q_pressure::torr    torr(v);
  return  q_pressure::Pa(torr)();
}


template<typename ValueT>
ValueT pa2torr(ValueT v)
{
  q_pressure::Pa    pa(v);
  ValueT torr_val = static_cast<ValueT>(floor(q_pressure::torr(pa)() + 0.5));
  return torr_val;
}

template<>
double pa2torr(double v)
{
  q_pressure::Pa pa(v);
  return q_pressure::torr(pa)();
}


} } } // *namespace* jyugem::bee::util

#endif  // JYUGEM_BEE_UTIL_PRESSURE_H
