// $Id$

//=============================================================================
/**
 *  @file    event_manager.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2003 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================


#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif

#include <boost/mpl/list.hpp>
#include <boost/format.hpp>


#include <ctime>
#include <iostream>
#include <string>

#include "jyugem/bee/task.h"

namespace bee = jyugem::bee;


//
namespace jyugem { namespace gem
{

//
// E30 : GENERIC MODEL FOR COMMUNICATIONS AND CONTROL OF MANUFACTURING EQUIPMENT
//


//
// Management of event
//
class event_manager : bee::task
{
public:
    event_manager() : bee::task("EventManager") {}
    virtual ~event_manager() {}

    // interface for other tasks
    virtual int notify(bee::trigger * trig, bee::task * tsk)
    {
        std::string now = trig->date().toSemi();
        std::cout << "<message=\"S6F11\">\n"
                  << "  <ceid type=\"ascii\">" << trig->name() << "</ceid>\n"
                  << "  <list>\n"
                  << "    <report type=\"ascii\">" << tsk->name() << "</report>\n"
                  << "    <report type=\"ascii\">" << now << "</report>\n"
                  << "  <list>\n"
                  << "</message>" << std::endl;
        // trigger * clone = new trigger(trig);
        // return m_activation_queue.enqueue(new trigger_request(clone, this));
        return 0;
    }

protected:

};


} }  // *namespace* jyugem::gem

