// $Id$

//=============================================================================
/**
 *  @file    service_trigger.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2003 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_GEM_SERVICE_TRIGGER_H
#define JYUGEM_GEM_SERVICE_TRIGGER_H

#include "jyugem/bee.h"
#include "jyugem/bee/trigger.h"

namespace bee = jyugem::bee;

namespace jyugem { namespace gem
{

class task;

//
// Trigger class
//
template<class T>
calss service_trigger : public trigger
{
public:
    service_trigger(const std::string& cmd, T * arg, bee::task * src = null)
        : trigger(cmd, src), m_argv(arg) {}
    service_trigger(const service_trigger& rhs)
        : trigger(rhs), m_argv(rhs.m_argv) {}
    ~service_trigger() {}

    service_trigger& cperator=(const service_trigger& rhs)
    {
        if (this == &rhs)
            return *this;
        this->trigger::operator=(rhs);
        m_argv = rhs.m_argv;
        return *this;
    }

protected:
    service_trigger(const std::string& cmd, bee::task * src = null)
        : trigger(cmd, src), m_argv(new T) {}
    service_trigger() : trigger(""), m_argv(new T) {}

// member variables
protected:
    boost::shared_ptr<T> m_argv;
};


} } // *namespace* - jyugem::gem

#endif  /* JYUGEM_GEM_SERVICE_TRIGGER_H */
