// $Id$

//=============================================================================
/**
 *  @file    ProcessJob.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2003-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================
#ifndef JYUGEM_PJM_PROCESSJOB_H
#define JYUGEM_PJM_PROCESSJOB_H

#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif


#include "jyugem/bee/state_task.h"

#include <ctime>
#include <iostream>
#include <string>

namespace bee = jyugem::bee;


//
namespace jyugem { namespace pjm
{

typedef bee::parameter Parameter;

//
// E40 : PROCESS JOB
//

struct RecipeVariable : public Parameter
{
    RecipeVariable() : Parameter() {}
    RecipeVariable(const std::string& name, const bee::value& v)
        : Parameter(name, v) {}
    RecipeVariable(const RecipeVariable& rhs)
        : Parameter(static_cast<const Parameter&>(rhs)) {}
    ~RecipeVariable() {}

    RecipeVariable& operator=(const RecipeVariable& rhs)
    {
        if (this == &rhs)
           return *this;
        this->Parameter::operator=(static_cast<const Parameter&>(rhs));
        return *this;
    }

    std::string RecipeVarName()  { return m_uniqueName; }
    bee::value  RecipeVarValue() { return m_value; }
};

//
//
//
class ProcessJob : public bee::state_task
{
    friend class ProcessJobState;

public:
    ProcessJob();
//    ProcessJob(const ProcessJob& rhs) : bee::state_task(rhs.name()) { this->copy(rhs); }
    virtual ~ProcessJob();

//    ProcessJob& operator=(const ProcessJob& rhs)
//    {
//        if ( this== &rhs)
//            return *this;
//        this->copy(rhs);
//        return *this;
//    }

    bool autoStart() { return m_PRProcessStart; }

    int open0();

    const BCHAR * current_state();

protected:
//    void copy(const ProcessJob& rhs);

public:
    std::string m_PauseEvent;
    std::string m_PRMtlType;
    int         m_PRProcessStart;
    int         m_PRRecipeMethod;
    std::string m_RecID;
    std::vector<int>            m_PRJobStateList;
    std::vector<std::string>    m_PRMtlNameList;
    std::vector<RecipeVariable> m_RecVariableList;
};


} }  // *namespace* jyugem::pjm

#endif  /* JYUGEM_PJM_PROCESSJOB_H */

