// $Id$

//=============================================================================
/**
 *  @file    ProcessJob.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#define BEE_BUILD_DLL

#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif

#include "state/ProcessJobState.h"
#include "jyugem/pjm/ProcessJob.h"
#include "jyugem/gem/event_manager.h"

namespace bee = jyugem::bee;
namespace gem = jyugem::gem;

//
namespace jyugem { namespace pjm
{

//
// Process Job
//

ProcessJob::ProcessJob() : bee::state_task("ProcessJob"), m_PauseEvent(_TX("")),
    m_PRMtlType(_TX("")),  m_PRProcessStart(0),
    m_PRRecipeMethod(0), m_RecID(_TX(""))
{
    ProcessJobState * pjm = new ProcessJobState(this);
    m_status = pjm;
    pjm->initiate();
}

ProcessJob::~ProcessJob()
{
    ProcessJobState * pjm = static_cast<ProcessJobState *>(m_status);
    pjm->terminate();
}

#if 0
void ProcessJob::copy(const ProcessJob& rhs)
{
    this->bee::state_task::operator =(rhs);
    m_PauseEvent = rhs.m_PauseEvent;
    m_PRJobStateList = rhs.m_PRJobStateList;
    m_PRMtlNameList = rhs.m_PRMtlNameList;
    m_PRMtlType = rhs.m_PRMtlType;
    m_PRProcessStart = rhs.m_PRProcessStart;
    m_PRRecipeMethod = rhs.m_PRRecipeMethod;
    m_RecID = rhs.m_RecID;
    m_RecVariableList = rhs.m_RecVariableList;
    m_status = new ProcessJobState(this);
    //
    // transit current_state();
    //
}
#endif

gem::event_manager evtmngr;

int ProcessJob::open0()
{
    ace::init();

    int result = this->open(null);
    this->on_trigger_connect(boost::bind(&gem::event_manager::notify, &evtmngr, _1, _2));

    return result;
}

const BCHAR * ProcessJob::current_state()
{
    ProcessJobState * cjm = static_cast<ProcessJobState *>(m_status);
    return cjm->current_state();
}


} }  // namespace

#if 0  // OBSOLETE

namespace PJM = jyugem::pjm;

std::string GetEvent()
{
    std::string key;
    std::cin >> key;
    return key;
}

int main( int argc, char * argv[] )
{
    argc;
    argv;

    if (ACE_LOG_MSG->open(_TX("JYUGEM"), ACE_Log_Msg::LOGGER,
                          ACE_DEFAULT_LOGGER_KEY) != -1)
    {
        std::cout << "Logging open error\n";
    }

    std::cout << "boost::fsm ProcessJob state model example\n\n";
    std::cout << "abort<CR>: Aborts process job\n";
    std::cout << "aborted<CR>: Aborted process job\n";
    std::cout << "start<CR>: Starts process job\n";
    std::cout << "cancel<CR>: Cancels process job\n";
    std::cout << "depart<CR>: Depart process job\n";
    std::cout << "complete<CR>: Comletes process job\n";
    std::cout << "alloc<CR>: Allocates process job\n";
    std::cout << "pause<CR>: Pauses process job\n";
    std::cout << "paused<CR>: Paused process job\n";
    std::cout << "resume<CR>: Resumes process job\n";
    std::cout << "stop<CR>: Stops process job\n";
    std::cout << "stopped<CR>: Stopped process job\n";
    std::cout << "quit<CR>: Quits the program\n\n";

    PJM::ProcessJob pjm;
    pjm.open();
    gem::event_manager evtmngr;

    pjm.on_trigger_connect(boost::bind(&gem::event_manager::notify, &evtmngr, _1, _2));

    std::string key = GetEvent();
    while ( key != "quit" )
    {
        if ( key == "state" )
        {
            std::cout << "current state = " << pjm.current_state()
                      << std::endl;
        }
        else
        {   // Notify trigger
            bee::trigger * trig = new bee::trigger(key);
            if (pjm.notify(trig, null) < 0)
            {
                std::cout << "Invalid key!\n";
            }
        }
        key = GetEvent();
    }

    pjm.close();

    return 0;
}

#endif
